package breakout;

import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JRadioButtonMenuItem;

public class BMenu {
	JMenuBar menuBar;
	ActionListener actionListener;
	static String[] fileItems = { "Open", "New", "Save", "ChangeColorset" , "Highscore", "Exit"};
	static String[] cheatItems = { "NextLevel" };
	static String[] helpItems = { "Help", "About", "Version" };

	/**
	 * ******************************************************************
	 * 
	 */
	public BMenu(Spiel aL) {
		actionListener = (ActionListener) aL;
		menuBar = new JMenuBar();
		addMenu("File", fileItems, "F_");
		addMenu("Cheat", cheatItems, "C_");
		addMenu("Help", helpItems, "H_");
	}

	/**
	 * ****************************************************************** Add a
	 * new menu. The title and the items define the layout of the menu. For
	 * example <BR>
	 * <CODE><B> addMenu</B>( "Help", {"About", "Version"}, "H_") </CODE> <BR>
	 * creates a help menu with two items. The header is the prefix of the
	 * action command. In the example the two action commands are H_About and
	 * H_Version.
	 */
	void addMenu(String title, String[] items, String header) {
		JMenu menu;
		JMenuItem menuItem;
		menu = new JMenu(title);
		menuBar.add(menu);
		for (int j = 0; j < items.length; j++) {
			if (items[j].equals("_")) {
				menu.addSeparator();
			} else {
				menuItem = myAddItem(items[j], header + items[j], actionListener);
				menu.add(menuItem);
			}
		}
	}

	/**
	 * ******************************************************************
	 * 
	 */
	private JMenuItem myAddItem(String lab, String msg, ActionListener li) {
		JMenuItem mi = new JMenuItem(lab);
		mi.setActionCommand(msg);
		String t = ToolTipText.get(msg);
		if (t != null)
			mi.setToolTipText(t);
		mi.addActionListener(li);
		return mi;
	} 
}