package breakout;

import java.awt.Color;
import java.awt.Graphics2D;

public class Drop extends Ball  {
	protected int score = 100;
	protected Color baseColor = Color.ORANGE;
	protected Color color = baseColor;

	public Drop(int x, int y) {
		this();
		this.x = x;
		this.y = y;
		baseColor = BColor.getDropBaseColor( this );
		color = baseColor;
	}

	public Drop() {
		super();
		width = 22;
		height = 11;
		this.vx = 0;
		this.vy = 3;
		baseColor = BColor.getDropBaseColor( this );
		color = baseColor;
	}

	@Override
	public void paintTo(Graphics2D g) {
		g.setColor(color);
		g.fillOval((int)(x-width/2), (int)(y-height/2), width, height);
	}

	@Override
	public void check(Brett brett) {
		if( y + width/2 > brett.getHeight() ) {
			brett.setRemoveDrop( this );
		}
	}

	public int getScore() {
		return score;
	}

	public void setScore(int score) {
		this.score = score;
	}

	/**
	 * Method to call when this drop is hit with the paddle. 
	 * 
	 * @param brett
	 */
	public void hit(Brett brett) {
	}

	public void move() {
		super.move();
		if( color == baseColor ) {
			color = color.darker();
		} else {
			color = baseColor;
		}
	}

}