package breakout;

/**
 * The listener interface for receiving game events. 
 * 
 * @author Euler
 *
 */
public interface GameChangeListener {
	/**
	 * Invoked when a new level start. 
	 * 
	 * @param level the number of the new level
	 * @param name  the name of the new lavel
	 */
	void levelHasChanged( int level, String name );
	/**
	 * Invoked when the number of lives has changed.
	 * @param live the new number of lives
	 */
	void liveHasChanged( int live );
	/**
	 * Invoked when the score has changed. 
	 * @param score the new score. 
	 */
	void scoreHasChanged( int score );
}