package breakout;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import javax.swing.JOptionPane;
import javax.xml.parsers.*; 
import org.jdom.*;
import org.jdom.input.SAXBuilder; 
import org.jdom.output.*;
import org.jdom.Document;
import org.w3c.dom.DocumentType;
import org.xml.sax.InputSource;

public class Highscore {

	private String highscore;
	DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	Document docxml;
	Element root = new Element("StartElement");
	Document doc = new Document(root);
	Vector<Spieler> spielerVector = new Vector<Spieler>();
	Vector<Spieler> spielerVectorListe = new Vector<Spieler>();
	private String spielername;
	private String spielerNameXml;
	private int spielerPunkteXml;
	private String spielerNameListe;
	private int spielerPunkteListe;

	public Highscore()  {
	}

	private void loadHighscore(){
		spielerVector.clear();
		SAXBuilder sxbuild = new SAXBuilder();
		InputSource is = new InputSource("xml/highscore.xml");
		Document doc;
		try {
			doc = sxbuild.build(is);
			Element root = doc.getRootElement();
			List list = root.getChildren("spieler");
			Iterator iterator = list.iterator();
			int i = 0;
			while(iterator.hasNext()){
				readAdress( (Element) iterator.next(),i);
				i++;
			}
			showHighscore();
		} catch (JDOMException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void readAdress(Element element, int i) {
		spielerVector.addElement(new Spieler(element.getChild("name").getText(),Integer.parseInt(element.getChild("punkte").getText()))); 
	}

	public int ueberpruefeName(Element element, String s) {
		if(element.getChild("name").getText().equals(s))
		{
			return 1;
		}
		return 0;
	}

	private void showHighscore(){
		highscore = "Die Highscoreliste:\n";
		Collections.sort(spielerVector);

		if(spielerVector.size()<5){
			for(int i=0; i<spielerVector.size(); i++){
				highscore += ((Spieler) spielerVector.elementAt(i)).getName() + ": " + ((Spieler) spielerVector.elementAt(i)).getPunkte() + "\n";
			}
		}else{
			for(int i=0; i<5; i++){
				highscore += ((Spieler) spielerVector.elementAt(i)).getName() + ": " + ((Spieler) spielerVector.elementAt(i)).getPunkte() + "\n";
			}
		}
	}

	public void schreibeSpielerListe(Vector<Spieler> spielerVectorListe) throws IOException, JDOMException{
		SAXBuilder builder = new SAXBuilder();
		Document doc = builder.build("xml/spielerliste.xml");
		Element root = doc.getRootElement();
		DocType testType = doc.getDocType();
		DocType doctype = new DocType("spielerliste", "spielerliste.dtd");
		if(testType == null|| testType.equals(doctype))
		{
			doc.setDocType(doctype);
		}
		if(!(doc.getContent(0)).toString().equals("[ProcessingInstruction: <?xml-stylesheet type=\"text/xsl\" href=\"spielerliste.xsl\"?>]")){
			HashMap piMap = new HashMap( 2 );
			piMap.put( "type", "text/xsl" );
			piMap.put( "href", "spielerliste.xsl" );
			ProcessingInstruction procIns = new ProcessingInstruction("xml-stylesheet",piMap);
			doc.getContent().add(0, procIns);
		}
		for(int i=0;i<spielerVectorListe.size();i++){
			spielerNameListe = spielerVectorListe.elementAt(i).getName();
			spielerPunkteListe = spielerVectorListe.elementAt(i).getPunkte();
			Element spielstand = new Element("spielstand");
			spielstand.addContent(new Element("spieler-ref").setAttribute("ref", spielerNameListe)).addContent(new Element("punkte").addContent(String.valueOf(spielerPunkteListe)));
			Element spielername = new Element("spielername");
			spielername.setAttribute("id",spielerNameListe).addContent(new Element("name").addContent(spielerNameListe));
			root.getChild("spielstaende").addContent(spielstand);
			List list = root.getChild("spieler").getChildren("spielername");
			Iterator iterator = list.iterator();
			int vorhanden = 0;
			while(iterator.hasNext()&& vorhanden == 0){
				vorhanden = ueberpruefeName((Element) iterator.next(),spielerNameListe);
			}
			if(vorhanden == 0)
			{
				root.getChild("spieler").addContent(spielername);
			}
			spielerVectorListe.removeAllElements();
		}

		XMLOutputter outputter = new XMLOutputter(Format.getPrettyFormat());
		FileOutputStream output;
		try {
			output = new FileOutputStream("xml/spielerliste.xml");
			outputter.output(doc,output);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public void writeHighscore(int score) throws IOException, JDOMException{
		loadHighscore();
		spielername = JOptionPane.showInputDialog("Bitte Namen eingeben:");
		if(spielername=="" || spielername==null){
			spielername = "";
			System.exit(0);
		}
		spielerVector.addElement(new Spieler(spielername,score));
		spielerVectorListe.addElement(new Spieler(spielername,score));
		schreibeSpielerListe(spielerVectorListe);
		Collections.sort(spielerVector);
		if(spielerVector.size()>5){
			spielerVector.remove(5);
		}
		Element root = new Element("highscore");
		Document dokument = new Document(root);
		DocType doctype = new DocType("highscore", "highscore.dtd");
		dokument.setDocType(doctype);
		HashMap piMap = new HashMap( 2 );
		piMap.put( "type", "text/xsl" );
		piMap.put( "href", "highscore.xsl" );
		ProcessingInstruction procIns = new ProcessingInstruction("xml-stylesheet",piMap);
		dokument.getContent().add(0, procIns);
		for(int i=0;i<spielerVector.size();i++){
			spielerNameXml = spielerVector.elementAt(i).getName();
			spielerPunkteXml = spielerVector.elementAt(i).getPunkte();
			Element spieler = new Element("spieler");
			spieler.setAttribute("id",spielerNameXml);
			spieler.addContent(new Element("name").addContent(spielerNameXml))
			.addContent(new Element("punkte").addContent(String.valueOf(spielerPunkteXml)));
			root.addContent(spieler);
		}
		XMLOutputter outputter = new XMLOutputter(Format.getPrettyFormat());
		FileOutputStream output;
		try {
			output = new FileOutputStream("xml/highscore.xml");
			outputter.output(dokument,output);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}       
	} 

	public String getHighscore(){
		loadHighscore();
		return highscore;
	}
}