package breakout;

import java.awt.Color;

import javax.swing.BorderFactory;
import javax.swing.JLabel;

public class Info extends JLabel implements GameChangeListener {
	private String scoreText = "Punkte: " ;
	private String liveText = "";
	private String levelText = "Level 0";
	private int gameOver = 1;

	public Info() {
		setText("Info");
		setBorder(BorderFactory.createMatteBorder(5, 5, 5, 5, Color.GRAY));
	}

	@Override
	public void liveHasChanged(int live) {
		liveText = "Leben: " + live;
		setText();
	}

	private void setText() {
		setText("<html>"+liveText + "  " + scoreText  + "  " + levelText +"</html>");
	}

	@Override
	public void scoreHasChanged(int score) {
		scoreText = "Punkte: " + score;
		setText();
	}

	@Override
	public void levelHasChanged(int level, String name ) {
		levelText = "Level " + level + " <em>" + name +"</em>";
		setText();
	}
}