package breakout;

import java.io.IOException;
import java.util.List;
import java.util.logging.Level;

import org.jdom.Attribute;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.xml.sax.InputSource;

public class LevelLoader {

	public LevelLoader() {
	}

	public breakout.Level loadLevel(int index) {
		breakout.Level levelDescription = new breakout.Level();
		
		SAXBuilder saxbuild = new SAXBuilder();
		InputSource is = new InputSource("xml/level.xml");
		Document doc;
		int izeile = 0;
		String[][] feld = null;
		try {
			doc = saxbuild.build(is);
			Element root = doc.getRootElement();
			List<Element> levels = root.getChildren("level");
			Element level = null;
			String target = "" + index;
			for (Element l : levels) {
				if (l.getAttribute("id").getValue().equals(target)) {
					level = l;
					break;
				}
			}
			if (level == null)
				return null;

			Element bild = level.getChild("bild");
			if (bild != null) {
				Attribute loc = bild.getAttribute("loc");
				levelDescription.setImage( loc.getValue() );
			}

			Element name = level.getChild("name");
			if (name != null) {
				levelDescription.setName( name.getValue() );
			}

			List<Element> rows = level.getChildren("row");
			for (Element e : rows) {
				int ispalte = 0;
				List<Element> zellen = e.getChildren("zelle");
				if (izeile == 0) {
					feld = new String[rows.size()][zellen.size()];
				}

				for (Element z : zellen) {
					feld[izeile][ispalte] = z.getAttribute("type").getValue();
					++ispalte;
				}
				++izeile;
			}
			levelDescription.setFeld( feld );
		} catch (JDOMException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// System.out.println( Arrays.deepToString( feld ) );
		return levelDescription;
	}

	public static void main(String[] args) {
		(new LevelLoader()).loadLevel(0);
	}

}