<?xml version="1.0" encoding="utf-8"?>
<!-- DWXMLSource="color.xml" -->
<!DOCTYPE xsl:stylesheet  [
	<!ENTITY nbsp   "&#160;">
	<!ENTITY copy   "&#169;">
	<!ENTITY reg    "&#174;">
	<!ENTITY trade  "&#8482;">
	<!ENTITY mdash  "&#8212;">
	<!ENTITY ldquo  "&#8220;">
	<!ENTITY rdquo  "&#8221;"> 
	<!ENTITY pound  "&#163;">
	<!ENTITY yen    "&#165;">
	<!ENTITY euro   "&#8364;">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" encoding="utf-8" doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"/>
<xsl:template match="/">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<title>Breakout Spielfarben</title>
<link rel="stylesheet" type="text/css" href="color.css"/>
</head>

<body>
<h1>Die verschiedenen Farbschema</h1>
<xsl:apply-templates />

</body>
</html>

</xsl:template>

<xsl:template match="colorset">
	<h2><xsl:value-of select="@name"/></h2>
   <div><xsl:apply-templates /></div>
</xsl:template>

<xsl:template match="MultiBlock">
	<div class="text">Multiblock</div>
    <div class="block">
    	<xsl:attribute name="style">background-color:<xsl:value-of select="@color"/></xsl:attribute>
	</div>
 	<div class="colorname"><xsl:value-of select="." /></div>
</xsl:template>

<xsl:template match="DecPaddleBlock">
	<div class="text">DecPaddleBlock</div>
    <div class="block">
    	<xsl:attribute name="style">background-color:<xsl:value-of select="@color"/></xsl:attribute>
	</div>
	<div class="colorname"><xsl:value-of select="." /></div>
</xsl:template>

<xsl:template match="IncPaddleBlock">
	<div class="text">IncPaddleBlock</div>
    <div class="block">
    	<xsl:attribute name="style">background-color:<xsl:value-of select="@color"/></xsl:attribute>
	</div>
	<div class="colorname"><xsl:value-of select="." /></div>
</xsl:template>

<xsl:template match="defaultBlockColor">
	<div class="text">defaultBlockColor</div>
    <div class="block">
    	<xsl:attribute name="style">background-color:<xsl:value-of select="@color"/></xsl:attribute>
	</div>
	<div class="colorname"><xsl:value-of select="." /></div>
</xsl:template>

<xsl:template match="DecPaddleDrop">
	<div class="text">DecPaddleDrop</div>
    <div class="drop">
    	<xsl:attribute name="style">background-color:<xsl:value-of select="@color"/>; border:1px solid <xsl:value-of select="@color"/></xsl:attribute>
	</div>
	<div class="colorname"><xsl:value-of select="." /></div>
</xsl:template>

<xsl:template match="IncPaddleDrop">
	<div class="text">IncPaddleDrop</div>
    <div class="drop">
    	<xsl:attribute name="style">background-color:<xsl:value-of select="@color"/>; border:1px solid <xsl:value-of select="@color"/></xsl:attribute>
    </div>
	<div class="colorname"><xsl:value-of select="." /></div>
</xsl:template>

<xsl:template match="ExtraBallDrop">
	<div class="text">ExtraBallDrop</div>
    <div class="drop">
    	<xsl:attribute name="style">background-color:<xsl:value-of select="@color"/>; border:1px solid <xsl:value-of select="@color"/></xsl:attribute>
	</div>
	<div class="colorname"><xsl:value-of select="." /></div>
</xsl:template>

<xsl:template match="defaultBaseColor">
	<div class="text">defaultBaseColor</div>
    <div class="drop">
    	<xsl:attribute name="style">background-color:<xsl:value-of select="@color"/>; border:1px solid <xsl:value-of select="@color"/></xsl:attribute>
	</div>
	<div class="colorname"><xsl:value-of select="." /></div>
</xsl:template>

</xsl:stylesheet>