package breakout;

import java.awt.Color;
import java.awt.Graphics2D;

public class Ball extends MovableGameObject  {
	int glueTimer = 0;
	private double vxMax = 5;
	
	public Ball(int x, int y, int vx, int vy) {
		this();
		this.x = x;
		this.y = y;
		this.vx = vx;
		this.vy = vy;
	}

	public Ball() {
		super();
		width = 11;
	}

	@Override
	public void paintTo(Graphics2D g) {
		//System.out.println( "Male auf " + g);
		g.setColor(Color.RED);
		g.fillOval((int)(x-width/2), (int)(y-width/2), width, width);
	}

	@Override
	public void check(Brett brett) {
		if( x + width/2 > brett.getWidth() ) {
			x -= width/2;
			vx = -vx;
		} 
		if( x < 0  ) {
			x = width/2;
			vx = -vx;
		}
		if( y + width/2 > brett.getHeight() ) {
			brett.setRemoveBall( this );
		}
		if( y < 0 ) {
			y = width/2;
			vy = -vy;
		}
	}

	public void noZeroVX() {
		if( vx == 0 ) vx = -1;		
	}

	public int getGlueTimer() {
		return glueTimer;
	}

	public void setGlueTimer(int glueTimer) {
		this.glueTimer = glueTimer;
	}

	public int advanceGlueTime(int deltaT) {
		glueTimer -= deltaT;
		return glueTimer;
	}

	public void changeV(double dvx, double dvy) {
		double speed = Math.sqrt( vx*vx + vy*vy );
		vx += dvx;
		vy += dvy;
		
		if( vx > vxMax ) vx = vxMax ;
		
		double speed2 = Math.sqrt( vx*vx + vy*vy );
		vx *= speed/speed2;
		vy *= speed/speed2;
	}

}
