package breakout;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.ImageObserver;
import java.util.Random;

import javax.swing.plaf.basic.BasicColorChooserUI;

public class Block extends GameObject {
	public static final int BLOCK_WIDTH = 40;
	public static final int BLOCK_HEIGHT = 12;
	static ImageObserver io = new MyImageObserver();
	
	protected int value = 100;
	protected Color color = Color.BLUE;
	protected Drop drop = null;
	private Random random = new Random();
	protected Image image = null;
	
	public Block() {
		super();
		width = BLOCK_WIDTH;
		height = BLOCK_HEIGHT;
		chooseDrop();
		color = BColor.getBlockColor( this );
	}

	public Block(int x, int y) {
		this();
		this.x = x;
		this.y = y;
	}

	private void chooseDrop() {
		if (random.nextInt(100) > 80) {
			drop = new ExtraBallDrop();
		} else {
			drop = new Drop();
		}
		
	}


	@Override
	void paintTo(Graphics2D g) {
		if (image != null) {
			g.drawImage(image, (int) (x - width / 2), (int) (y - height / 2),
					color, io);
		} else {
			g.setColor(color);
			g.fill3DRect((int) (x - width / 2), (int) (y - height / 2), width,
					height, true);
		}

	}

	public void hit(Brett brett) {
		brett.addToScore( value );
		brett.removeBlock(this);
		if( drop != null ) {
			drop.setPos( x,  y);
			drop.setVy( 2.5 );
			brett.addDrop( drop );
		}
	}

	public Drop getDrop() {
		return drop;
	}

	public void setDrop(Drop drop) {
		this.drop = drop;
	}

	/**
	 * @return the img
	 */
	public Image getImage() {
		return image;
	}

	/**
	 * @param img the img to set
	 */
	public void setImage(Image img) {
		this.image = img;
	}

}
