package breakout;

import java.awt.Color;
import java.awt.Graphics2D;

public abstract class GameObject  {
	double x = 133;
	double y = 255;
	protected int width = 30;
	protected int height = 10;;

	public boolean isLeftOf( GameObject go ) {
		return x+width/2 < go.getX()-go.getWidth()/2;
	}
	
	public boolean isRightOf( GameObject go ) {
		return x-width/2 > go.getX()+go.getWidth()/2;
	}
	
	public boolean isAboveOf( GameObject go ) {
		return y+height/2 < go.getY()-go.getHeight()/2;
	}
	
	public boolean isBelowOf( GameObject go ) {
		return y-height/2 > go.getY() + go.getHeight()/2;
	}
	
	public boolean hits(GameObject go) {
		if( isLeftOf(go)) return false;
		if( isRightOf(go)) return false;
		if( isAboveOf(go)) return false;
		if( isBelowOf(go)) return false;
		return true;
	}

	abstract void paintTo(Graphics2D g);
	
	public double getX() {
		return x;
	}

	public void setX(double x) {
		this.x = x;
	}

	public double getY() {
		return y;
	}

	public void setY(double y) {
		this.y = y;
	}

	public void setPos(double x, double y) {
		this.x = x;
		this.y = y;
	}

	public int getWidth() {
		return width;
	}

	public void setWidth(int width) {
		this.width = width;
	}

	public int getHeight() {
		return height;
	}

	public void setHeight(int height) {
		this.height = height;
	}
	
	public void addSize( int w, int h ) {
		width += w;
		height += h;
	}

}
