package breakout;

import java.awt.Color;
import java.awt.Graphics2D;
import java.util.ArrayList;
import java.util.List;


public class Schlaeger extends MovableGameObject  {
	List<Ball> kugeln = new ArrayList<Ball>();
	List<Ball> release = new ArrayList<Ball>();
	
	public Schlaeger( Brett brett) {
		x = brett.getWidth() / 2;
		y = brett.getHeight() - 30;
		vy = 0;
//		width = 30;
	}
	@Override
	public void paintTo(Graphics2D g) {
		//System.out.println( "Male auf " + g);
		g.setColor(Color.BLACK);
		g.fill3DRect((int)(x-width/2), (int)( y - height/2), width, height, true);
	}

	@Override
	public void check(Brett brett) {
		if( x + width/2 > brett.getWidth() ) {
			x = brett.getWidth() - width/2;
			vx = -vx;
		} 
		if( x < width/2 ) {
			x = width/2;
			vx = -vx;
		}
		
		// move glued balls
		for( Ball k : kugeln ) {
			if( k.getGlueTimer()  > 0) {
//				System.out.println( "T: " +k.getGlueTimer());
				if( k.advanceGlueTime( Spiel.DELTA_T) < 0 ) {
					release.add(k);
				}
			}
			k.setX( x );
		}
		for( Ball k : release ) {
			kugeln.remove(k);
			k.setV(2,-3);
		}
		release.clear();
	}
	
	public static int speed(int dist) {
		int v = (int)Math.sqrt( Math.abs( dist ) );
		return  v;
	}
	
	public void glue(Ball neu) {
		kugeln.add( neu );
	}
	public void releaseKugel() {
		if( ! kugeln.isEmpty()) {
			Ball k = kugeln.remove(0);
			k.setV(2,-3);
		}
		
	}

}
