package breakout;

import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.Timer;

public class Spiel extends JFrame implements ActionListener {
	public static final int DELTA_T = 15;
	static final String aboutText = "FH-Friedberg Breakout demo";
	static final String helptext = "No help available";
	protected BMedia bmedia;
	
	Brett brett = new Brett();
	Info info = new Info();

	private String version = " Version 0.8 Oct 2009";

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		(new Spiel()).start();

	}

	private void start() {
		bmedia = new BMedia( this );
		
		setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE);
		setTitle("Break Out " + version );
		brett.setSpiel( this );
		getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
		//getContentPane().setLayout(new  BorderLayout());
		getContentPane().add( info );
		getContentPane().add( brett );
		pack();
		
		BMenu bMenu = new BMenu(this);
		setJMenuBar(bMenu.menuBar); 
		
		setVisible(true);		
		
		brett.addChangeListener( info );
		brett.nextLevel();
		
		repaint();
		
		Timer t = new Timer( DELTA_T, new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				doOnTick();
				
			}
		});
		t.start();
	}

	protected void doOnTick() {
		brett.move();
		repaint();
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		String cmd = e.getActionCommand();
		System.out.println("command: " + cmd);
		
		if (cmd.equals("F_Exit")) { 
			System.exit(0);
		 			} else if (cmd.equals("H_Version")) {
			JOptionPane.showMessageDialog(this, "Current version: "
					+ version );
		} else if (cmd.equals("H_About")) {
			JOptionPane.showMessageDialog(this, aboutText);
		} else if (cmd.equals("H_Help")) {
			JOptionPane.showMessageDialog(this, helptext); 
		}
	}

	/**
	 * @return the bmedia
	 */
	public BMedia getBmedia() {
		return bmedia;
	}


}
